#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2500three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 2500"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2500three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three25004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three25004xi = {
                1:'0x2426y-601z',
                2:'1003x2253y-405z',
                3:'100x1986y-1674z',
                4:'1021x2094y-906z',
                5:'1022x1776y-1431z',
                6:'1031x1943y-1187z',
                7:'104x92y-2496z',
                8:'1121x1732y-1410z',
                9:'1121x2201y-380z',
                10:'1133x2045y-883z',
                11:'1138x1896y-1165z',
                12:'118x246y-2484z',
                13:'1218x1683y-1390z',
                14:'1237x2143y-355z',
                15:'1242x1843y-1142z',
                16:'1244x1990y-859z',
                17:'127x2429y-576z',
                18:'129x102y-2494z',
                19:'1313x1627y-1369z',
                20:'1343x1785y-1120z',
                21:'1349x2078y-331z',
                22:'1351x1929y-836z',
                23:'138x671y-2404z',
                24:'1406x1566y-1348z',
                25:'143x262y-2482z',
                26:'1442x1721y-1098z',
                27:'1455x1863y-812z',
                28:'1458x2007y-306z',
                29:'145x2093y-1359z',
                30:'1495x1500y-1327z',
                31:'1538x1651y-1075z',
                32:'154x109y-2492z',
                33:'1556x1790y-788z',
                34:'1563x1930y-281z',
                35:'1582x1429y-1305z',
                36:'1630x1575y-1053z',
                37:'1653x1712y-765z',
                38:'1663x1848y-256z',
                39:'1664x1352y-1284z',
                40:'169x275y-2478z',
                41:'16x123y-2496z',
                42:'1718x1495y-1030z',
                43:'1743x1270y-1262z',
                44:'1746x1628y-741z',
                45:'1760x1760y-231z',
                46:'179x686y-2397z',
                47:'1802x1409y-1007z',
                48:'1834x1539y-717z',
                49:'1851x1667y-206z',
                50:'1881x1319y-984z',
                51:'1918x1445y-693z',
                52:'1937x1569y-181z',
                53:'197x2252y-1067z',
                54:'198x1918y-1590z',
                55:'198x286y-2475z',
                56:'1996x1346y-669z',
                57:'2018x1466y-156z',
                58:'222x699y-2389z',
                59:'227x295y-2472z',
                60:'23x32y-2499z',
                61:'254x2424y-552z',
                62:'256x2096y-1338z',
                63:'259x301y-2468z',
                64:'267x709y-2382z',
                65:'27x146y-2495z',
                66:'28x612y-2423z',
                67:'291x305y-2464z',
                68:'2x74y-2498z',
                69:'301x1921y-1571z',
                70:'313x715y-2374z',
                71:'316x2249y-1044z',
                72:'325x306y-2459z',
                73:'359x305y-2455z',
                74:'35x2084y-1380z',
                75:'361x719y-2366z',
                76:'367x2092y-1316z',
                77:'382x2413y-527z',
                78:'394x300y-2450z',
                79:'404x1918y-1551z',
                80:'410x720y-2358z',
                81:'41x169y-2493z',
                82:'41x50y-2499z',
                83:'429x293y-2445z',
                84:'435x2239y-1021z',
                85:'460x717y-2350z',
                86:'479x2083y-1295z',
                87:'508x1909y-1531z',
                88:'509x2395y-503z',
                89:'510x711y-2341z',
                90:'554x2223y-998z',
                91:'561x702y-2332z',
                92:'57x190y-2492z',
                93:'591x2067y-1274z',
                94:'60x66y-2498z',
                95:'612x1894y-1512z',
                96:'613x689y-2323z',
                97:'635x2370y-479z',
                98:'63x634y-2417z',
                99:'664x672y-2314z',
                100:'672x2201y-975z',
                101:'703x2046y-1252z',
                102:'715x1873y-1492z',
                103:'716x652y-2304z',
                104:'759x2338y-454z',
                105:'75x211y-2489z',
                106:'767x628y-2294z',
                107:'78x2248y-1089z',
                108:'790x2171y-952z',
                109:'814x2017y-1230z',
                110:'817x601y-2284z',
                111:'818x1847y-1472z',
                112:'82x80y-2497z',
                113:'866x570y-2274z',
                114:'882x2299y-429z',
                115:'8x12y-2499z',
                116:'8x99y-2498z',
                117:'906x2136y-929z',
                118:'921x1814y-1451z',
                119:'923x1983y-1209z',
                120:'95x229y-2487z',
                121:'99x654y-2410z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire2500three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire2500three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2500THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2500THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2500THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE2500THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2500THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three25004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2500THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2500THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2500THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three25004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three<8shot2three25004xi/nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2500THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2500THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2500THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2500three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                